﻿Imports NHibernate
Imports NHibernate.Cfg
Imports log4net
Imports System.Configuration
Imports NHibernate.Connection
Imports Iesi.Collections

Public Class Form1

    Private Sub btnSalvar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSalvar.Click
        Dim mConfig As New Configuration

        'definindo o assembly para carregar os arquivo .hbm.xml  que fazem parte do mesmo
        mConfig.AddAssembly("usandoNHibernate")

        'definindo o dialeto do banco de dados
        mConfig.SetProperty("hibernate.dialect", "NHibernate.Dialect.MsSql2005Dialect")

        'criando uma sessao e iniciando uma transação
        Dim mFactory As ISessionFactory = mConfig.BuildSessionFactory
        Dim mSession As ISession = mFactory.OpenSession
        Dim mTransaction As ITransaction = mSession.BeginTransaction


        'criando um novo objeto funcionario
        Dim funci As New funcionario

        'obtendo os valores fornecidos no formulário
        'e preenchendo o objeto
        funci.Codigo = txtCodigo.Text
        funci.Nome = txtNome.Text
        funci.Salario = txtSalario.Text

        'persistindo os dados no banco de dados
        mSession.Save(funci)

        'fecha a transação e a sessão
        mTransaction.Commit()
        mSession.Close()

        MsgBox("Dados do objeto funcionario foram persistidos com sucesso na tabela : funcionario.")

    End Sub

    Private Sub btnCarregar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCarregar.Click
        Dim mConfig As New Configuration

        'definindo o assembly para carregar os arquivo .hbm.xml  que fazem parte do mesmo
        mConfig.AddAssembly("usandoNHibernate")

        'definindo o dialeto do banco de dados
        mConfig.SetProperty("hibernate.dialect", "NHibernate.Dialect.MsSql2005Dialect")

        'criando uma sessao e iniciando uma transação
        Dim mFactory As ISessionFactory = mConfig.BuildSessionFactory
        Dim mSession As ISession = mFactory.OpenSession
        Dim mTransaction As ITransaction = mSession.BeginTransaction

        Dim f As funcionario = DirectCast(mSession.Load(GetType(funcionario), 1), funcionario)

        txtCodigo.Text = f.Codigo
        txtNome.Text = f.Nome
        txtSalario.Text = f.Salario

        mSession.Flush()

        'fecha a transação e a sessão
        mTransaction.Commit()
        mSession.Close()

    End Sub

    Private Sub btnListar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnListar.Click
        Dim mConfig As New Configuration
        'definindo o assembly para carregar os arquivo .hbm.xml  que fazem parte do mesmo
        mConfig.AddAssembly("usandoNHibernate")

        'definindo o dialeto do banco de dados
        mConfig.SetProperty("hibernate.dialect", "NHibernate.Dialect.MsSql2005Dialect")

        'criando uma sessao e iniciando uma transação
        Dim mFactory As ISessionFactory = mConfig.BuildSessionFactory
        Dim mSession As ISession = mFactory.OpenSession
        Dim mTransaction As ITransaction = mSession.BeginTransaction

        Dim listaFuncionarios As IList = mSession.CreateCriteria(GetType(funcionario)).List()

        For Each f As funcionario In listaFuncionarios
            lstFuncionarios.Items.Add(f.Codigo & " - " & f.Nome & " - " & f.Salario)
        Next

        'fecha a transação e a sessão
        mTransaction.Commit()
        mSession.Close()

    End Sub
End Class
